use crate::test_utils::TestRandom;
use crate::Hash256;
use serde_derive::{Deserialize, Serialize};
use ssz_derive::{Decode, Encode};
use test_random_derive::TestRandom;
use tree_hash::TreeHash;
use tree_hash_derive::TreeHash;

#[derive(Debug, PartialEq, Clone, Serialize, Deserialize, Encode, Decode, TreeHash, TestRandom)]
pub struct SigningRoot {
    pub object_root: Hash256,
    pub domain: u64,
}

pub trait SignedRoot: TreeHash {
    fn signing_root(&self, domain: u64) -> Hash256 {
        SigningRoot {
            object_root: self.tree_hash_root(),
            domain,
        }
        .tree_hash_root()
    }
}
